/* 
 * wsdlpull - A C++ parser  for WSDL  (Web services description language)
 * Copyright (C) 2005-2007 Vivek Krishna
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _UTILSH
#define _UTILSH

#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <exception>
#ifdef HAVE_CONFIG_H //
#include <config.h>
#endif             

//put all miscellaneous  utiliy functions here
namespace XmlUtils {
  int parseInt (std::string s, int radix = 10);
  std::ostream & dbsp (std::ostream & str);
  std::ostream & blk (std::ostream & str);
  bool fetchUri(std::string uri,std::string & path);
  std::string acceptSecretKey(const std::string& field);
  //network related stuff
  extern bool proxy;
  extern std::string proxy_host;
  extern std::string proxy_user;
  extern std::string proxy_pass;
};
#endif                                            /*  */
